<?php
final class apple_notification
    {
        protected $ctx = NULL;
        protected $passphrase = 'C0dnl0can44';
        protected $cert_file_path = 'alkaziminews_pro_cat.pem';
        protected $fp = NULL;
        function connect()
            {
                $error = "";
                $error_str = "";
                $this->ctx = stream_context_create();
                stream_context_set_option($this->ctx, 'ssl', 'local_cert', $this->cert_file_path);
                stream_context_set_option($this->ctx, 'ssl', 'passphrase', $this->passphrase);
                $this->fp = stream_socket_client('ssl://gateway.push.apple.com:2195', $error,$error_str, 60, STREAM_CLIENT_CONNECT|STREAM_CLIENT_PERSISTENT, $this->ctx);
                return ((empty($this->fp))?false : true);
            }
            
        function reconnect()
            {
                $error = "";
                $error_str = "";
                fclose($this->fp);
                $this->fp = stream_socket_client('ssl://gateway.push.apple.com:2195', $error,$error_str, 60, STREAM_CLIENT_CONNECT|STREAM_CLIENT_PERSISTENT, $this->ctx);
            }
            
        function prepare_payload($payload_elements_arr = array(),$badge = 1)
            {
                $body = array();
                $body['aps'] = array('alert' => array(),'badge' => $badge,'sound' => 'newMessage.wav');
                foreach($payload_elements_arr as $key => $element)
                    {
                        if($key == "body")
                            $body['aps']['alert']['body'] = $element;
                        else
                            $body['aps'][$key] = $element;
                    }
                return json_encode($body);
            }
            
        private function _prepare_message($token,$payload,$with_callback = 0)
            {
                if($with_callback == 1)
                    $msg = pack("C", 1) . pack("N", $token) . pack("N",  time() + 86400) . pack("n", 32) . pack('H*', str_replace(' ', '', $token)) . pack("n", strlen($payload)) . $payload;
                else
                    $msg = chr(0) . pack('n', 32) . pack('H*', $token) . pack('n', strlen($payload)) . $payload;
                return $msg;
            }
            
        function send_payload($payload,$token,$with_callback = 0)
            {
                $msg = $this->_prepare_message($token,$payload,$with_callback);
                // Send it to the server
                $result = fwrite($this->fp, $msg, strlen($msg));
                $error = 0;
                if($with_callback == 1)
                    $error = $this->check_error_response();
                if($error == 1)
                    $this->reconnect();
                return (($error == 0) ? true : false);
            }

        function check_error_response()
            {
                stream_set_blocking($this->fp, false);
                $break_counter = 0;
                $apple_error_response = '';
                $info = stream_get_meta_data($this->fp);
                while(!$info['timed_out'] && !feof($this->fp))
                    {
                        $str = @fgets($this->fp, 6);
                        if ($str)
                            {
                                $apple_error_response .= $str;
                            }
                        else
                            {
                                $break_counter += 1;

                                if ($break_counter > 100)
                                    {
                                        break;
                                    }
                                usleep(10000);
                            }
                        $info = stream_get_meta_data($this->fp);
                    }
                //$apple_error_response = fread($this->fp, 6);
                $is_critical_error = 0;
                if ($apple_error_response)
                    {
                        $error_response = unpack('Ccommand/Cstatus_code/Nidentifier', $apple_error_response);

                        if ($error_response['status_code'] != '0')
                            {
                                $is_critical_error = 1;
                                //$error_response['status_code'] = '0-No errors encountered';
                            }

                        return $is_critical_error;
                    }
                return 0;
            }
        function disconnect()
            {
                fclose($this->fp);
            }
    }