<?php    
function send_news($news_infos = array("t" => "", "l" => "", "c" => "", "a" => "", "ca" => "", "i" => "", "v" => "", "u" => "", "ti" => "", "lo" => "", "uu" => ""))
    {
        global $db, $news_program_name, $website_url, $visitors_tbl;
        @session_start();
        $ip = $website_url;
        if (empty($db))
            $db = new db();

        //json object that will be returned in case of errors , each one for the suitable statement
        $invalid_infos_json_error = json_encode(array("s" => '001'));
        $malformed_error_json = json_encode(array("s" => '002'));
        $invalid_token_error_json = json_encode(array("s" => '003'));
        $unsufficient_permissions_error_json = json_encode(array("s" => '004'));
        $invalid_language_error_json = json_encode(array("s" => '005'));
        $empty_content_error_json = json_encode(array("s" => '006'));

        //array of keys that are valid to use in a send news request , and the valid keys for non users (guest) to send
        $valid_indexes_arr = array("t","l","c","a","ca","i","v","u","ti","lo","uu","wa","tw","fb","d","tags","id_news","newApp");
        $guest_valid_indexes_arr = array("l","c","ca","i","v","ti","lo","uu","newApp");

        //Check if the request is valid (has no invalid keys , has count of keys less or equal to the count of valid keys,has a key that contain the language of the news, and has a key that contains content of news and this content is not empty)
        $is_valid_request = validate_news_request($news_infos, $valid_indexes_arr);
        if(!is_array($is_valid_request))
            {
                if($is_valid_request == -1)
                    return $invalid_infos_json_error;
                else if($is_valid_request == -2)
                    return $malformed_error_json;
                else if($is_valid_request == -3)
                    return $invalid_language_error_json;
                else if($is_valid_request == -4)
                    return $empty_content_error_json;
            }
        $news_active = 0;
        $notify = 2;
        $news_urgent = 0;
        $notification_token = "";
        $news_agency = "Guest";
        
        //default social configs
        $whatsapp_configs = array("send" => 0, "pic" => 1, "full" => 1);
        $facebook_configs = array("send" => 0, "pic" => 0, "full" => 0);
        $twitter_configs = array("send" => 0, "title" => "","pic" => 1,"link" => 0);
        $telegram_configs = array("send" => 0, "pic" => 1, "full" => 2);
        
        $news_language_var = $is_valid_request[0];//Lang id
        $news_language = $news_language_var;
    
        if (isset($news_infos['t']))
            {
                $is_valid_token_row = validate_news_token($news_infos);
                if ($is_valid_token_row === false)
                    {
                        return $invalid_token_error_json;
                    }
                $user_id = $is_valid_token_row->UserId;
                $user_nick_name = $is_valid_token_row->NickName;
                $uuid = $is_valid_token_row->uuid;
                $is_admin_var = $db->get_var("select AdminId from admins where AdminId = '$user_id'");
                if ($is_admin_var)
                    {
                        if (isset($news_infos['d']))
                            {
                                $news_active = $news_infos['d'];
                            }
                        $whatsapp_configs = get_whatsapp_configs($news_infos,$whatsapp_configs);
                        $facebook_configs = get_facebook_configs($news_infos,$facebook_configs);
                        $twitter_configs = get_twitter_configs($news_infos,$twitter_configs);
                        $telegram_configs = get_telegram_configs($news_infos,$telegram_configs);
                        $send_to_application = !isset($news_infos['application']) || (isset($news_infos['application']) && $news_infos['application'] == 1) ? 1 : 0;
                        
                        if ($news_active == 1)
                            {
                                $notification_token = md5(time() . time() . rand(0, 999));
                                $news_urgent = isset($news_infos['u']) && !empty($news_infos['u']) && $news_infos['u'] == 1 ? 1 : 0;
                                $passed_agency = isset($news_infos['a']) && !empty($news_infos['a']) ? InputFilter($news_infos['a']) : $user_nick_name;
                                $is_valid_agency_var = $db->get_var("select NickName from users as u,groups as g where g.GroupId = u.GroupId and (md5(u.NickName) = '" . md5($passed_agency) . "' or u.NickName = '$user_nick_name') and g.GroupName = 'agencies'");
                                $news_agency = $is_valid_agency_var ? $is_valid_agency_var : $user_nick_name;
                            }
                        else
                            {
                                $notification_token = md5(time() . time() . rand(4000, 9999));
                                $news_agency = $user_nick_name;
                                $is_user = 1;
                            }
                    }
                else
                    {
                        $notification_token = md5(time() . time() . rand(4000, 9999));
                        $news_agency = $user_nick_name;
                        $is_user = 1;
                    }
            }
        else
            {
                foreach ($news_infos as $info_name => $info_value)
                    {
                        if (!in_array($info_name, $guest_valid_indexes_arr))
                            return $unsufficient_permissions_error_json;
                    }
                $is_guest = 1;
                $notification_token = md5(time() . time() . rand(4000, 9999));
                $user_id = '20070000000';
                $uuid = isset($news_infos['uu']) && $db->get_var("select uuid from $visitors_tbl where uuid = '" . InputFilter($news_infos['uu']) . "'") ? InputFilter($news_infos['uu']) : "";
            }

        $points_to_add = 1;
        $news_image = 'newspaper.png';
        $news_images_arr = array();
        $news_id = GenerateID('news', 'IdNews');
        $news_date = date('Y-m-d H:i:s', time());
        $news_location = isset($news_infos['lo']) ? InputFilter($news_infos['lo']) : "0,0";
        $news_link = isset($news_infos['li']) && !empty($news_infos['li'])?$news_infos['li'] : "";
        
        $passed_news_body = trim($news_infos['c']);
        $w_tags_news_body = strip_tags($passed_news_body);
        $news_body = str_replace(array("\n"), array("<line>"), $w_tags_news_body);
        
        //Check if passed title is an empty title and if it is let the title be the body of the news
        $passed_news_title = isset($news_infos['ti']) && !empty($news_infos['ti']) ? str_replace(array("\n"), array(" "), $news_infos['ti']) : str_replace(array("<line>"), array(" "), $news_body);
        $passed_news_title = trim($passed_news_title);
        $new_title_to_check = strip_tags($passed_news_title);
        $new_title_to_check = str_replace(array("\n", " ", "&nbsp;"), array("", "", ""), $new_title_to_check);
        if (empty($new_title_to_check))
            $passed_news_title = str_replace(array("<line>"), array(" "), $news_body);
        //remove all special characters from the title
        $news_title_to_replace = InputFilter($passed_news_title);
        $news_title = str_replace(array("/", "\\", "@", "#"), array(" ", " ", "", ""), $news_title_to_replace);
        //if this request is not un update request check if their is any other news with same title and abort request if their is , to prevent duplication of news
        $is_duplicated_news = check_title_beyond_duplication($news_infos,$news_title,$news_language_var);
        if($is_duplicated_news)
            return $empty_content_error_json;
    
        $news_subtitle = "";
        $news_full_brief = str_replace(array("<line>"), array(" "), $news_body);
        $news_brief = mb_substr($news_full_brief, 0, 500, "utf8");
        $news_full_message_full = str_replace(array("<line>"), array("<br />"), $news_body);
        $news_full_message = InputFilter($news_full_message_full);
        $news_full_message = replace_people_images($news_program_name,$news_full_message);

        //get categories of the news to insert in later step to newscategoies table
        $news_categories = array();
        if (isset($news_infos['ca']))
            {
                $news_categories = is_array($news_infos['ca'])?$news_infos['ca'] : array(InputFilter($news_infos['ca']));
            }
        else
            {
                $news_categories = array("20100000000");
            }
        $news_category = $news_categories[0];
        $passed_news_images = isset($news_infos['i']) && !empty($news_infos['i']) ? InputFilter($news_infos['i']) : "";
        $passed_news_videos = isset($news_infos['v']) && !empty($news_infos['v']) ? InputFilter($news_infos['v']) : "";
        $news_images_path_arr = array();
        if (isset($news_infos['i']) && !empty($news_infos['i']))
            {
                $passed_news_images_arr = explode('||', $passed_news_images);
                foreach ($passed_news_images_arr as $passed_news_image)
                    {
                        if(strpos($passed_news_image,"uploads/gallery/") === 0 || strpos($passed_news_image,"uploads/news/") === 0)
                            {
                                if(file_exists("../../$passed_news_image"))
                                    {
                                        if(strpos($passed_news_image,"uploads/news/") === 0)
                                            {
                                                $gallery_news_image = str_replace(array('uploads/news/pics/'),array('uploads/gallery/Albums/'),$passed_news_image);
                                                if(file_exists("../../$gallery_news_image"))
                                                    $passed_news_image = $gallery_news_image;
                                            }
                                        $news_images_arr[] = $passed_news_image;
                                        $news_images_path_arr[] = $passed_news_image;
                                    }
                            }
                        else if (file_exists("../../uploads/gallery/Albums/$year/$day-$month-$year/$passed_news_image"))
                            {
                                $news_images_arr[] = "/$passed_news_image";
                                $news_images_path_arr[] = "uplodas/gallery/Albums/$year/$day-$month-$year/$passed_news_image";
                            }
                    }

                if (isset($news_images_arr) && is_array($news_images_arr) && count($news_images_arr) > 0)
                    {
                        file_put_contents("newsimageslog.txt",json_encode($news_images_arr)."\n\n",FILE_APPEND);
                        if(strpos($news_images_arr[0],"uploads/gallery/") === 0)
                            {
                                $im = $news_images_arr[0];
                                $news_path_image = str_replace(array('uploads/gallery/Albums/'),array('uploads/news/pics/'),$im);
                                $news_image = $news_path_image;
                            }
                        else if(strpos($news_images_arr[0],"uploads/gallery/") === 0)
                            {
                                $news_image = $news_images_arr[0];
                            }
                        else
                            $news_image = "uploads/news/pics/$year/$day-$month-$year/" . $news_images_arr[0];
                        if ($news_agency !== 'Guest')
                            {
                                $points_to_add += 2;
                            }
                    }
            }

    if (isset($news_infos['v']) && !empty($news_infos['v']))
        {
            $news_videos_array = explode('||', InputFilter($news_infos['v']));
            if ($news_agency !== 'Guest')
                {
                    $points_to_add += 3;
                }
            if ((isset($is_user) && $is_user == 1) || (isset($is_guest) && $is_guest == 1))
                {
                    $mail_phpmailer = new PHPMailer();
                    ob_start();
                    $notification_email = defined('api_new_unpublished_video_notification_email') ? api_new_unpublished_video_notification_email : "user@$website_url";
                    $mailed = api_send_email($mail_phpmailer, "user@$website_url", "New youtube video", $notification_email, "A video has been uploaded to youtube please check it !", "A user or a guest has been uploaded a video for a news on youtube please check it to approove or reject !", "");
                    $output = ob_get_clean();
                }
        }
    else
        {
            $news_videos_array = array();
        }
    if (!isset($news_infos['id_news']))
        {
            $insert_news_sql = "insert into news(IdNews,IdUserName,Date,Active,Hits,NewsPic,Deleted,urgent,agency,location,uuid,news_points) values ('$news_id','$user_id','$news_date','$news_active','$news_hits','$news_image','$news_deleted','$news_urgent','$news_agency','$news_location','$uuid',$points_to_add)";
            $insert_news_qu = $db->query($insert_news_sql);
        }
    else
        {
            $news_id = $news_infos['id_news'];
            $d = $news_infos['d'];
            $update_news_sql = "update news set IdUserName = '$user_id', Date = '$news_date', Active = '$d', Hits = '$news_hits', NewsPic = '$news_image', Deleted = '$news_deleted', urgent = '$news_urgent', agency = '$news_agency', location = '$news_location', uuid = '$uuid', news_points = $points_to_add where IdNews = '$news_id'";
            file_put_contents("editnewsrequestlog.txt", $update_news_sql . "\n\n", FILE_APPEND);
            $update_news_qu = $db->query($update_news_sql);
            $delete_news_categories = "delete from newscategoies where IdNews='$news_id'";
            $delete_news_images = "delete from news_images where IdNews='$news_id'";
            $delete_news_videos = "delete from news_videos where IdNews='$news_id'";
            $delete_news_lang = "delete from newslang where IdNews='$news_id'";
            $update_news_qu = $db->query($delete_news_categories);
            $update_news_qu = $db->query($delete_news_images);
            $update_news_qu = $db->query($delete_news_videos);
            $update_news_qu = $db->query($delete_news_lang);
        }
    if ($db->dbh->affected_rows > 0)
        {
            if ($news_urgent == 1)
                {
                    $marquee_message = str_replace(array(":", "/", "\\", "@", '"', "'", "#"), array("", " ", " ", "", "", "", ""), $news_title);
                    $marquee_title_in_link = mb_substr($marquee_message, 0, 40, "utf8");
                    $marquee_id = GenerateID('marques', 'idMarque');
                    $marquee_link = CreateLink('', array('Prog', 'ns', 'idnews', 'title'), array($news_program_name, 'details', $news_id, $marquee_title_in_link));
                    $marquee_start_date = date('Y-m-d H:i:s', time());
                    $marquee_end_date = date('Y-m-d H:i:s', strtotime("$marquee_start_date +30 hours"));
                    $db->query("insert into marques(idMarque,Link,StartDate,EndDate,Deleted) values('$marquee_id','$marquee_link','$marquee_start_date','$marquee_end_date','0')");
                    $db->query("insert into marqlang(idmarque,idLang,Message) values('$marquee_id','$news_language','$marquee_message')");
                }
        foreach ($news_categories as $category_row)
            {
                $insert_news_category_sql = "insert into `newscategoies` values('$news_id','$category_row')";
                $insert_news_category_qu = $db->query($insert_news_category_sql);
            }
        //$insert_news_category_sql;

        $news_full_message .= "\n" . '<div id="news_desc_images_wrapper_div">';
        $all_images = '<br />';
        if (count($news_images_path_arr) > 0)
            {//If their is any image uploaded
                $db->query("insert into news_images(news_id,images_paths,news_title) values('$news_id','" . json_encode($news_images_path_arr) . "','$news_title')");
                $counter = 0;
                $image_info = str_replace(array('{', '}', "'", '"', ':'), array('', '', '', '', ''), $news_title);
                $watermark_path = "../../Programs/gallery/admin/img/water.png";
                $watermark_logo_path = "../../Programs/gallery/admin/img/water-logo.png";
                $watermark_ribbon_path = "../../Programs/gallery/admin/img/water-ribbon.png";
                $watermark_center_path = "../../Programs/gallery/admin/img/water-center.png";
                foreach ($news_images_arr as $news_image_row)
                    {
                        if ($counter === 0)
                            {
                                create_news_pic_thumbs_and_watermark_them($news_image_row);
                            }
                        $extension = pathinfo($news_image_row, PATHINFO_EXTENSION);
                        $media_id = GenerateID("gallery", 'IdMedia');
                        $media_path = "$ip/uploads/gallery/Albums/$year/$day-$month-$year/$news_image_row";
                        $addition_date = $news_date;
                        $media_location = "";
                        $media_rank = "";
                        $media_type = $extension;
                        $news_caption = InputFilter($news_title);
                        $Desc = "";
                        $Place = "";
                        $Tags = "";
                        //$insert_to_gallery_sql = "insert into gallery(IdMedia,Path,AddDate,MapLocation,MediaRank,MediaType) values ('$media_id','$media_path','$addition_date','$media_location','$media_rank','$media_type')";
                        //$insert_to_gallery_qu = $db->query($insert_to_gallery_sql);
                        //$insert_into_gallery_lang_sql = "insert into gallerylang(`IdMedia`,`IdLang`,`Caption`,`Desc`,`Place`,`Tags`) values ('$media_id','$news_language','$news_caption','$Desc','$Place','$Tags')";
                        //$insert_into_gallery_lang_qu = $db->query($insert_into_gallery_lang_sql);
                        $all_images .= "<div class='news_desc_images'><img src='$ip/$news_image_row' alt='$image_info' title='$image_info' /></div>";
                        $counter++;
                    }
            }
        else
            {
                if (is_file("../../uploads/gallery/Albums/$news_category/$rand_name.jpg") && $news_urgent === 1)
                    {
                        $all_images .= "<div class='news_desc_images'><img src='$ip/uploads/gallery/Albums/$news_category/$rand_name.jpg' /></div>";
                    }
            }
        if (count($news_images_arr) > 0)
            $all_videos = '<br />';
        if (count($news_videos_array) > 0)
            {/* If their is any video uploaded */
                $db->query("insert into news_videos(news_id,videos_ids,news_title) values('$news_id','" . json_encode($news_videos_array) . "','$news_title')");
                foreach ($news_videos_array as $news_video)
                    {
                        if ($notify == 1)
                            {
                                publish_video($news_video, $news_title);
                            }
                        $IdMedia = GenerateID("gallery", 'IdMedia');
                        $Path = "uploads/gallery/Albums/$year/$day-$month-$year/$news_video";
                        $AddDate = $news_date;
                        $MapLocation = "";
                        $MediaRank = "";
                        $MediaType = "youtube";
                        $Caption = InputFilter($news_title);
                        $Desc = "";
                        $Place = "";
                        $Tags = "";
                        $insert_to_gallery_sql = "insert into gallery(IdMedia,Path,AddDate,MapLocation,MediaRank,MediaType) values ('$IdMedia','$Path','$AddDate','$MapLocation','$MediaRank','$MediaType')";
                        $insert_to_gallery_qu = $db->query($insert_to_gallery_sql);
                        $insert_into_gallery_lang_sql = "insert into gallerylang(`IdMedia`,`IdLang`,`Caption`,`Desc`,`Place`,`Tags`) values ('$IdMedia','$news_language','$Caption','$Desc','$Place','$Tags')";
                        $insert_into_gallery_lang_qu = $db->query($insert_into_gallery_lang_sql);
                        $all_videos .= '<div class="news_desc_videos">'
                                . '<iframe width="420" height="315" src="//www.youtube.com/embed/' . $news_video . '" frameborder="0" allowfullscreen></iframe>'
                                . '</div>';
                    }
            }
        $news_full_message .= $all_images . $all_videos . '</div>';
        str_replace(array('src=\"//', 'src=\'//', 'src=//'), array('src="http://', 'src=\'http://', 'src=http://'), $news_full_message);
        if ($notify === 1)
            {
                $news_title = str_replace(array('{', '}'), array('<', '>'), $news_title);
                $news_title = mysqli_real_escape_string($db->dbh, $news_title);

                $news_subtitle = str_replace(array('{', '}'), array('<', '>'), $news_subtitle);
                $news_subtitle = mysqli_real_escape_string($db->dbh, $news_subtitle);

                $news_brief = str_replace(array('{', '}'), array('<', '>'), $news_brief);
                $news_brief = mysqli_real_escape_string($db->dbh, $news_brief);

                $news_full_message = str_replace(array('{', '}'), array('<', '>'), $news_full_message);
                $news_full_message = mysqli_real_escape_string($db->dbh, $news_full_message);

                $news_full_message = str_replace(array('clickX', '<aX'), array('click', '<a'), $news_full_message);
                //$news_full_message = addslashes($news_full_message);
                if (isset($news_infos['tags']) && !empty($news_infos['tags']))
                    {
                        $news_tags = $news_infos['tags'];
                        $insert_news_lang_sql = "insert into newslang(IdLang,IdNews,Tilte,SubTitle,Breif,FullMessage,Note, tags) values ('$news_language','$news_id','$news_title','$news_subtitle','$news_brief','$news_full_message','$news_note', '$news_tags')";
                    }
                else
                    $insert_news_lang_sql = "insert into newslang(IdLang,IdNews,Tilte,SubTitle,Breif,FullMessage,Note) values ('$news_language','$news_id','$news_title','$news_subtitle','$news_brief','$news_full_message','$news_note')";
            }
        else
            {
                $news_title = mysqli_real_escape_string($db->dbh, $news_title);
                $news_subtitle = mysqli_real_escape_string($db->dbh, $news_subtitle);
                $news_brief = mysqli_real_escape_string($db->dbh, $news_brief);
                $news_full_message = str_replace(array("'"),array('"'),$news_full_message);
                if (isset($news_infos['tags']) && !empty($news_infos['tags']))
                    {
                        $news_tags = $news_infos['tags'];
                        $insert_news_lang_sql = "insert into newslang(IdLang,IdNews,Tilte,SubTitle,Breif,FullMessage,Note, tags) values ('$news_language','$news_id','$news_title','$news_subtitle','$news_brief','$news_full_message','$news_note', '$news_tags')";
                    }
                else
                    {
                        $news_full_message = mysqli_real_escape_string($db->dbh, $news_full_message);
                        $insert_news_lang_sql = "insert into newslang(IdLang,IdNews,Tilte,SubTitle,Breif,FullMessage,Note) values ('$news_language','$news_id','$news_title','$news_subtitle','$news_brief','$news_full_message','$news_note')";
                    }
            }
        //file_put_contents("write_query.sql",$insert_news_lang_sql."\n",FILE_APPEND);
        $insert_news_lang_qu = $db->query($insert_news_lang_sql);

        if ($db->dbh->affected_rows > 0)
            {
                $db->query("update users set points = points + $points_to_add where UserId = '$user_id'");
                //file_put_contents("write_query.sql","update users set points = points + $points_to_add where UserId = '$user_id'"."\n",FILE_APPEND);
            }
        if (!empty($notification_token))
            {
                $_SESSION['notification'][$notification_token]['token'] = $notification_token;
                $_SESSION['notification'][$notification_token]['news_id'] = $news_id;
                $_SESSION['notification'][$notification_token]['type'] = $notify;
                if (isset($whatsapp_configs))
                    {
                        if ($whatsapp_configs["send"] == 1)
                            {
                                $_SESSION['notification'][$notification_token]['whatsapp'] = $whatsapp_configs;
                            }
                        else
                            {
                                $_SESSION['notification'][$notification_token]['whatsapp'] = 0;
                            }
                    }
                if (isset($facebook_configs))
                    {
                        if ($facebook_configs['send'] == 1)
                            {
                                $_SESSION['notification'][$notification_token]['facebook'] = $facebook_configs;
                            }
                        else
                            {
                                $_SESSION['notification'][$notification_token]['facebook'] = 0;
                            }
                    }
                if (isset($twitter_configs))
                    {
                        if ($twitter_configs['send'] == 1)
                            {
                                $_SESSION['notification'][$notification_token]['twitter'] = $twitter_configs;
                            }
                        else
                            {
                                $_SESSION['notification'][$notification_token]['twitter'] = 0;
                            }
                    }
                if (isset($telegram_configs))
                    {
                        if ($telegram_configs["send"] == 1)
                            {
                                $_SESSION['notification'][$notification_token]['telegram'] = $telegram_configs;
                            }
                        else
                            {
                                $_SESSION['notification'][$notification_token]['telegram'] = 0;
                            }
                    }
                if (isset($send_to_application))
                    {
                        if ($send_to_application == 1)
                            {
                                $_SESSION['notification'][$notification_token]['application'] = 1;
                            }
                        else
                            {
                                $_SESSION['notification'][$notification_token]['application'] = 0;
                            }
                    }
            }
        session_write_close();
        return json_encode(array("s" => '1', "r" => array("id" => $news_id, "no" => $notify, "to" => $notification_token,"se" => session_id())));
    }
}
    
function submit_news($user_id,$date,$active,$agency,$urgent,$location,$link,$pictures,$videos,$youtube_videos,$body,$notify,$notification_token,$user_nick_name,$social_configs,$send_to_application,$news_categories,$news_id = "")
    {
        global $db,$news_program_name,$website_url,$visitors_tbl;
        if(!empty($news_id))
            {
                $db->query("update news set IdUserName = '$user_id',Date = '$date',Active = $active,NewsPic = '$picture',agency = '$agency',urgent = $urgent,active_by='$user_id',location = '$location',news_link='$link',news_pictures = '$pictures',news_videos = '$videos',youtube_videos = '$youtube_videos',news_audios = '' where IdNews = '$news_id'");
                clear_news_infos($news_id);
            }
        else
            {
            
            }
        set_news_categories($news_id,$news_categories);
        $news_added_to_marquee = $db->get_var("select IdNews from marques where IdNews = '$news_id'");
        if ($urgent == 1)
            {
                if(!$news_added_to_marquee)
                    add_news_to_marquee($news_id,$date);
            }
        else
            {
                if($news_added_to_marquee)
                    $db->query("delete from marques where IdNews = '$news_id'");
            }
    }
/********************************************* Utilities ****************************************/

//validate the post request beyond valid keys,valid language ,valid news body
function validate_news_request($news_infos,$valid_indexes_arr)
    {
        global $db;
        if(empty($db))
            $db = new db();
        if (!isset($news_infos) || !is_array($news_infos) || count($news_infos) > count($valid_indexes_arr) || count($news_infos) <= 0)
            return -1;
        $index = 0;
        foreach ($news_infos as $info_name => $info_value)
            {
                if (!in_array($info_name, $valid_indexes_arr))
                    return -2;
                $index ++;
            }
        $passed_language = isset($news_infos['l']) && !empty($news_infos['l']) ? InputFilter($news_infos['l']) : "";
        if (empty($passed_language))
            return -3;
        else
            {
                $news_language_var = $db->get_var("select IdLang from languages where LangName = '$passed_language' and Deleted != 1");
                if (!$news_language_var)
                    return -3;
                $passed_news_body = isset($news_infos['c']) && !empty($news_infos['c']) ? $news_infos['c'] : "";
                $passed_news_body = trim($passed_news_body);
                if (empty($passed_news_body))
                    return -4;
            }
        return array($news_language_var);
    }
    
function validate_news_token($news_infos)
    {
        global $db;
        if(empty($db))
            $db = new db();
        $passed_token = InputFilter($news_infos['t']);
        $is_valid_token_row = $db->get_row("select * from users where app_token = '$passed_token'");
        if (!$is_valid_token_row)
            {
                return false;
            }
        else
            {
                return $is_valid_token_row;
            }
    }
        
function check_title_beyond_duplication($news_infos,$news_title,$news_language_var)
    {
        global $db;
        if(empty($db))
            $db = new db();
        if(!isset($news_infos['id_news']))
            {
                $is_duplicated_news = $db->get_var("select Tilte from newslang where Tilte = '$news_title' and IdLang = '$news_language_var'");
                if ($is_duplicated_news)
                    {
                        return true;
                    }
                //If the length of the title is more than 20 and the request is not an update request than test if this title is included in any founded news , to prevent duplications
                if (strlen($news_title) > 20)
                    {
                        $trimmed_news_title = substr($news_title, 10, -10);
                        $is_like_another_news = $db->get_var("select Tilte from newslang where Tilte like '%$trimmed_news_title%' and IdLang = '$news_language_var'");
                        if($is_like_another_news)
                            {
                                return true;
                            }
                    }
            }
        return false;
    }
    
//Delete all data in tables related to news
function clear_news_infos($news_id)
    {
        global $db;
        if(empty($db))
            $db = new db();
        $db->query("delete from newscategoies where IdNews = '$news_id'");
        $db->query("delete from newslang where IdNews = '$news_id'");
    }
    
//Set categories for a specific news by its id
function set_news_categories($news_id,$news_categories)
    {
        global $db;
        if(empty($db))
            $db = new db();
        if (is_array($news_categories))//multiple categories selected
            {
                $insert_news_categories_prefix_sql = "insert into newscategoies (IdNews,IdCat) values ";
                $insert_news_categories_suffix_arr = array();
                foreach ($news_categories as $catid)
                    {
                        $insert_news_categories_suffix_arr[] = "('$news_id','$catid')";
                    }
                $insert_news_categories_suffix_sql = implode(',', $insert_news_categories_suffix_arr);
                $insert_news_categories_sql = $insert_news_categories_prefix_sql . $insert_news_categories_suffix_sql;
                $db->query($insert_news_categories_sql);
            }
        else
            {
                $db->query("insert into `newscategoies` (`IdNews`,`IdCat`) values('$news_id','$news_categories');");
            }
    }
 
    
/************************************************** Media utilities ****************************************************/
    
function replace_people_images($news_program_name,$news_full_message)
    {
        $people_images = (glob("../../Programs/$news_program_name/people/*.jpg"));
        $people_names = array();
        $g = 0;
        if(count($people_images) > 0)
            {
                foreach ($people_images as $filename)
                    {
                        $slash_pos = strrpos($filename, "/");
                        $dot_pos = strrpos($filename, ".");
                        $people_names[$g] = substr($filename, $slash_pos + 1, $dot_pos - $slash_pos - 1);
                        $people_images[$g] = $people_names[$g] . '<img alt="' . $people_names[$g] . '" alt="' . $people_names[$g] . '" src="' . $filename . '" style="max-width:40% !important;margin-right:5px;float:left !important" /> <br />';
                        $people_names[$g] = '/' . $people_names[$g] . '/';
                        $g++;
                    }
                $news_full_message = preg_replace($people_names, $people_images, $news_full_message, 1);
            }
        return $news_full_message;
    }
    
//Add a marquee with the title and link with news id that start from date to 30 hours after this date
function add_news_to_marquee($newsID,$date,$title)
    {
        global $db,$conn, $TotalRecords, $Recordset, $Rows, $Lang, $TimeFormat;
        if(empty($db))
            $db = new db();
        //Generate an id for the new marquee
        $idMarque = GenerateID("marques", "idMarque");
        //Calculate the start date and the end date of the marquee
        $StartDate = date('Y-m-d H:i:s', time());
        $EndDate = date('Y-m-d H:i:s', strtotime("$StartDate +30 hours"));
        
        //Create the link of the marquee
        $Link = CreateLinkNoLang("", array("Prog", "ns", "idnews"), array("news", "details", $newsID));
        
        //Insert the marquee infos to the marques table
        $db->query("insert into `marques` (`idMarque`,`StartDate`,`EndDate`,`Link`,`IdNews`) values('" . $idMarque . "','" . $StartDate . "','" . $EndDate . "','" . $Link . "','" . $newsID . "');");

        //Fetch all valid languages and iterate through them and insert the title as the value of the caption inside the marqlang that is suitable to this marque
        $languages_res = $db->get_results("SELECT `IdLang`,`LangName` FROM `languages` where Deleted != 1;");
        if ($languages_res)
            {
                foreach($languages_res as $language_row)
                    {
                        $IdLang = $language_row->IdLang;
                        $LangName = $language_row->LangName;
                        $MarqueeMessage = $title;
                        $db->query("insert into `marqlang` (`idmarque`,`idLang`,`Message`) values('" . $idMarque . "','" . $IdLang . "','" . $MarqueeMessage . "');");
                    }//END For
            }//end if
    }
    
/**
 * 
 * Process all the pictures of the news and save them into gallery and change visibility of them as needed
 * @global db $db
 * @param type $unique_news_pictures_arr
 * @param type $gallery_picture_path
 * @param type $media_visible
 * @param type $parent_id
 * @param type $media_ids_arr
 * @return type
 */
function process_news_pictures($unique_news_pictures_arr,$gallery_picture_path,$media_visible,$parent_id,$media_ids_arr)
    {
        global $db;
        if(empty($db))
            $db = new db();
        //Iterate through passed news pictures array
        foreach($unique_news_pictures_arr as $news_picture_row)
            {
                if(empty($news_picture_row))
                    continue;
                //Extract the picture file name and append it to the gallery path to construct their media path to store in the gallery
                $news_picture_to_save_arr = explode('/',$news_picture_row);
                $news_picture_to_save = end($news_picture_to_save_arr);
                $news_picture_to_save = $gallery_picture_path . "/" . $news_picture_to_save;
                
                //If the file path is not inside the gallery prepend the gallery static path to it
                $media_path = strpos($news_picture_row,"uploads/gallery/Albums/")===false?"uploads/gallery/Albums/$news_picture_to_save" : $news_picture_row;
                $media_type = "jpg";
                $file_infos = pathinfo($media_path);
                if(isset($file_infos['extension']))
                    {
                        $extension = $file_infos['extension'];
                        $media_type = $extension;
                    }
                //Check if the media path is found inside database and if it is not , generate a new media id and store it with the generated id and return their media id
                $db_exists = $db->get_var("select IdMedia from gallery where Path = '$media_path'");
                if(!$db_exists)
                    {
                        $media_id = GenerateID('gallery', 'IdMedia');
                        $db->query("insert into gallery(IdMedia,Path,AddDate,MediaType,visible,ParentId) values('$media_id','$media_path','".date('Y-m-d H:i:s',time())."','$media_type',$media_visible,'$parent_id')");
                    }
                else
                    {
                        $media_id = $db_exists;
                    }
                //Update the visibility of media withing gallery as needed (0 => News is draft , 1 => News is active)
                $db->query("update gallery set visible = $media_visible where IdMedia = '$media_id'");
                $media_ids_arr[]= $media_id;
            }
        return $media_ids_arr;
    }
    
/**
 * Process all passed videos and store them as needed inside gallery
 * @global db $db
 * @param type $unique_news_videos_arr
 * @param type $gallery_picture_path
 * @param type $media_visible
 * @param type $parent_id
 * @param type $media_ids_arr
 * @return type
 */
function process_news_videos($unique_news_videos_arr,$gallery_picture_path,$media_visible,$parent_id,$media_ids_arr)
    {
        global $db;
        if(empty($db))
            $db = new db();
        //Iterate through passed videos
        foreach($unique_news_videos_arr as $video)
            {
                if(empty($video))
                    continue;
                //Assume that the type of the video is youtube
                $media_type = "youtube";
                $media_file = "";
                //If the file path has :// in it  so it is external , check its extension and type
                if(strpos($video,'://') !== false)
                    {
                        $media_file = $video;
                        $file_infos = pathinfo($video);
                        if(isset($file_infos['extension']))
                            {
                                $extension = $file_infos['extension'];
                                $media_type = $extension;
                            }
                    }
                else if(strpos($video,'uploads') === 0)//if the file path contains the word uploads as the first word index in the path so it is a gallery path
                    {
                        $media_file = $video;
                        $file_infos = pathinfo($video);
                        $extension = $file_infos['extension'];
                        $media_type = $extension;
                    }
                else if(strpos($video,".youtube") !== false)//If the file path contain .youtube within it so it is a path of the .youtube file we create when we recieve the response from youtube when uploading the video
                    {
                        $media_file = $video;
                    }
                else//Assume that path is a youtube id and fetch the image of this youtube id and put it inside the suitable gallery path
                    {
                        $media_file = $video.".youtube";
                        file_put_contents("../../../../uploads/gallery/Albums/$gallery_picture_path/$media_file",@file_get_contents("http://img.youtube.com/vi/$video/hqdefault.jpg"));
                        $media_file = "uploads/gallery/Albums/$gallery_picture_path/$media_file";
                    }
                if(!empty($media_file))//If all above steps are working as might we must have a non empty value inside the media file variable
                    {
                        //Check if media file path exist in the database
                        $media_exists_db = $db->get_var("select IdMedia from gallery where Path = '$media_file'");
                        //If it does not exist , create a new row inside the gallery table and anyway return the media id
                        if(!$media_exists_db)
                            {
                                $media_id = GenerateID('gallery', 'IdMedia');
                                $db->query("insert into gallery(IdMedia,Path,AddDate,MediaType,visible,ParentId) values('$media_id','$media_file','".date('Y-m-d H:i:s',time())."','$media_type',$media_visible,'$parent_id')");
                            }
                        else
                            {
                                $media_id = $media_exists_db;
                            }
                        //Add the media id to the array of media id that we will updaten their captions by the title of the news
                        $media_ids_arr[]= $media_id;
                    }
            }
        return $media_ids_arr;
    }
    
/**
 * 
 * @global db $db
 * @param type $unique_youtube_videos_arr
 * @param type $gallery_picture_path
 * @param type $media_visible
 * @param type $parent_id
 * @param type $media_ids_arr
 * @return type
 */
function process_news_youtube_videos($unique_youtube_videos_arr,$gallery_picture_path,$media_visible,$parent_id,$media_ids_arr)
    {
        global $db;
        if(empty($db))
            $db = new db();
        foreach($unique_youtube_videos_arr as $youtube_video)
            {
                if(empty($youtube_video))
                    continue;
                //each youtube video must have a .youtube file in the gallery folder
                $path = "uploads/gallery/Albums/$gallery_picture_path/$youtube_video".".youtube";
                //if the path to current youtube id is not found inside the gallery create it and put inside it the screen capture of the video from youtube
                if(!file_exists("../../$path"))
                    {
                        $youtube_img = @file_get_contents("http://img.youtube.com/vi/$youtube_video/hqdefault.jpg");
                        @file_put_contents("../../".$path,$youtube_img);
                    }
                //Check that the path is inside database if it is not create it , then anyway return the media id
                $path_exists_in_db = $db->get_var("select IdMedia from gallery where Path = '$path'");
                if(!$path_exists_in_db)
                    {
                        $media_id = GenerateID('gallery','IdMedia');
                        $db->query("insert into gallery(IdMedia,Path,AddDate,MediaType,visible,ParentId) values('$media_id','$path','".date('Y-m-d H:i:s',time())."','youtube',$media_visible,'$parent_id')");
                    }
                else
                    {
                        $media_id = $path_exists_in_db;
                    }
                //Add the media id to the array of medias that will be updated by the title of the news
                $media_ids_arr[] = $media_id;
            }
        return $media_ids_arr;
    }
    
/*********************************************** Social Utilities *******************************************/
    
//Fetch the whatsapp post field to get the suitable options for sending the news and return them withing the config array passed as second element
function get_whatsapp_configs($news_infos,$whatsapp_configs)
    {
        //If website has enabled the whatsapp api
        if (!defined('api_send_to_whatsapp') || (defined('api_send_to_whatsapp') && api_send_to_whatsapp == 1))
            {
                $whatsapp_arr = isset($news_infos['wa']) && is_array($news_infos['wa'])?$news_infos['wa'] : false;
                //If the whatsapp element ['wa'] inside the posted infos is a valid array
                if($whatsapp_arr)
                    {
                        if ($whatsapp_arr['wa'] == 1)//We want to send this news to whatsapp
                            {
                                $whatsapp_configs["send"] = 1;
                                if (isset($whatsapp_arr["pic"]) && $whatsapp_arr["pic"])
                                    $whatsapp_configs["pic"] = $whatsapp_arr["pic"];
                                if (isset($whatsapp_arr["news"]) && $whatsapp_arr["news"] == 1)
                                    $whatsapp_configs["type"] = 2;
                                else
                                    $whatsapp_configs["type"] = 1;
                            }
                    }
            }
        return $whatsapp_configs;
    }
    
//Fetch the facebook post field to get the suitable options for sending the news and return them withing the config array passed as second element
function get_facebook_configs($news_infos,$facebook_configs)
    {
        //If website has enabled the facebook api
        if (!defined('api_send_to_facebook') || (defined('api_send_to_facebook') && api_send_to_facebook == 1))
            {
                $facebook_arr = isset($news_infos['fb']) && is_array($news_infos['fb'])?$news_infos['fb'] : false;
                if($facebook_arr)
                    {
                        if ($facebook_arr['fb'] == 1)//We want to send this news to facebook
                            {
                                $facebook_configs['send'] = 1;
                                if (isset($facebook_arr['pic']) && $facebook_arr['pic'])
                                    $facebook_configs['pic'] = $facebook_arr['pic'];
                                if (isset($facebook_arr['news']) && $facebook_arr['news'])
                                    $facebook_configs['type'] = 2;
                                else
                                    $facebook_configs['type'] = 1;
                            }
                    }
            }
        return $facebook_configs;
    }
    
//Fetch the twitter post field to get the suitable options for sending the news and return them withing the config array passed as second element
function get_twitter_configs($news_infos,$twitter_configs)
    {
        //If website has enabled the twitter api
        if (!defined('api_send_to_twitter') || (defined('api_send_to_twitter') && api_send_to_twitter == 1))
            {
                $twitter_arr = isset($news_infos['tw']) && is_array($news_infos['tw'])?$news_infos['tw'] : false;
                if($twitter_arr)
                    {
                        if ($twitter_arr['tw'])//We want to send this news to twitter
                            {
                                $twitter_configs['send'] = 1;
                                $twitter_configs['message'] = $twitter_arr['ti'];
                                if(isset($twitter_arr['pic']))
                                    $twitter_configs['pic'] = $twitter_arr['pic'];
                                if(isset($twitter_arr['link']))
                                    $twitter_configs['link'] = $twitter_arr['link'];
                            }
                    }
            }
        return $twitter_configs;
    }
    
//Fetch the telegram post field to get the suitable options for sending the news and return them withing the config array passed as second element
function get_telegram_configs($news_infos,$telegram_configs)
    {
        //If website has enabled the telegram api
        if (!defined('api_send_to_telegram') || (defined('api_send_to_telegram') && api_send_to_telegram == 1))
            {
                $telegram_arr = isset($news_infos['tg']) && is_array($news_infos['tg'])?$news_infos['tg'] : false;
                if($telegram_arr)
                    {
                        if ($telegram_arr['tg'] == 1)//We want to send this news to telegram
                            {
                                $telegram_configs["send"] = 1;
                                if (isset($telegram_arr["pic"]) && $telegram_arr["pic"])
                                    $telegram_configs["pic"] = $telegram_arr["pic"];
                                if (isset($telegram_arr["news"]) && $telegram_arr["news"] == 1)
                                    $telegram_configs["type"] = 2;
                                else
                                    $telegram_configs["type"] = 1;
                            }
                    }
            }
        return $telegram_configs;
    }

?>