<?php
class gallery_selector
    {
        private $db;
        private $gallery;
        
        public function __construct($db)
            {
                $this->set_db($db);
            }
        function set_db($_db)
            {
                $this->db = $_db;
            }
            
        function get_db()
            {
                return $this->db;
            }
            
        function select_file($query,$fields = "*",$tables=array("gallery"),$relation = "",$conditions = array(),$order = "desc",$groupby = "",$start = 0,$limit = 10)
            {
                $db = $this->get_db();
                $record_set = $db->get_results($query);
                if($record_set)
                    return $record_set;
                else
                    return false;
            }
            
        function get_gallery($gallery_record_set,$_template,$call_back = NULL)
            {
                $final_result = "";
                if(file_exists($_template))
                    $template = get_include_contents ($_template);
                foreach($gallery_record_set as $gallerys_record_row)
                    {
                        $current_gallery_template = $_template;
                        $gallery_IdMedia = isset($gallerys_record_row->gIdMedia)?$gallerys_record_row->gIdMedia : '';
                        $gallery_ParentId = isset($gallerys_record_row->ParentId)?$gallerys_record_row->ParentId : '';
                        $gallery_Path = isset($gallerys_record_row->Path)?$gallerys_record_row->Path : '';
                        $gallery_AddDate = isset($gallerys_record_row->AddDate)?$gallerys_record_row->AddDate : '';
                        $gallery_MapLocation = isset($gallerys_record_row->MapLocation)?$gallerys_record_row->MapLocation : '';
                        $gallery_MediaRank = isset($gallerys_record_row->MediaRank)?$gallerys_record_row->MediaRank : '';
                        $gallery_MediaType = isset($gallerys_record_row->MediaType)?$gallerys_record_row->MediaType : '';
                        $gallery_visible = isset($gallerys_record_row->visible)?$gallerys_record_row->visible : '';
                        $gallery_Caption = isset($gallerys_record_row->Caption)?$gallerys_record_row->Caption : '';
                        $gallery_Desc = isset($gallerys_record_row->Desc)?$gallerys_record_row->Desc : '';
                        $gallery_Place = isset($gallerys_record_row->Place)?$gallerys_record_row->Place : '';
                        $gallery_Tags = isset($gallerys_record_row->Tags)?$gallerys_record_row->Tags : '';
                        
                        
                        
                        $tags_to_replace_arr = array("detailmedia","checkicon","icon","filename","caption","date","html","mediarank","optionshowhide","optioncomment","optionedit","optiondelete");
                        $values_to_put_arr = $this->get_array_gallery(
                                $gallery_IdMedia,$gallery_ParentId,$gallery_Path,$gallery_AddDate,$gallery_MapLocation,
                                $gallery_MapLocation,$gallery_MediaRank,$gallery_MediaType,$gallery_visible,
                                $gallery_Caption,$gallery_Desc,$gallery_Place,$gallery_Tags);
                        
                        $current_gallery = str_replace($tags_to_replace_arr,$values_to_put_arr,$current_gallery_template);
                        $final_result .= $current_gallery;
                    }
                return $final_result;
            }
        function IsImage($type){
            $upload_images = array("jpg","gif","png","bmp","jpeg","JPG","GIF","PNG","BMP","JPEG");
            foreach ($upload_images as $v)
            {
                if($v == $type)
                    return true;
            }
            return false;
            
        }function IsVideos($type){
            $upload_videos = array("webm", "3gpp", "mpegps", "mpeg4", "mov", "wmv", "flv", "swf", "rm", "avi", "mp4", "mpeg", "mpg", "youtube", "wma");
            foreach ($upload_videos as $v)
            {
                if($v == $type)
                    return $v;
            }
            return false;
        }
        function IsFile($type){
            $upload_files = array("pdf", "ppt", "pptx", "tiff", "doc", "docx", "xls", "xlsx", "rtf", "txt", "ods", "odt", "odp", "odg");
            if($type == "pdf")
            {
                return "pdf.jpg";
            }
            if($type == "ppt" or $type == "pptx" )
            {
                return "ppt.png";
            }
            if($type == "doc" or $type == "docx" )
            {
                return "docs.png";
            }
            if($type == "xls" or $type == "xlsx")
            {
                return "xls.png";
            }
            if($type == "txt")
            {
                return "txt-file-1.png";
            }
            return false;
        }
        function get_array_gallery($gallery_IdMedia,$gallery_ParentId,$gallery_Path,$gallery_AddDate,$gallery_MapLocation,$gallery_MapLocation,$gallery_MediaRank,$gallery_MediaType,$gallery_visible,$gallery_Caption,$gallery_Desc,$gallery_Place,$gallery_Tags)
        {   
            
            global $Lang,$WebsiteUrl;
            include_once  'Languages/lang-'.$Lang.'.php';
            $html='';
            $filename1 = basename($gallery_Path);
            $filename = "<a href='$gallery_Path' target='_blank'>$filename1</a> ";
            // create table icon 
            $icon;
            if($gallery_MediaType == "folder")
            {
                $link=AdminCreateLink("", array('prog','subdo','pid','fold'), array('gallery','allMedia',$gallery_IdMedia,'ent'));
                
                
                $icon = "<a class='folder_enter' href='$link' val='$gallery_Path'><img src='Programs/gallery/admin/images/folder.png' class='allmedia_icon'></a>";
                
                
                // create table file name 
                $linkname="admin/includes/webfolder/index.php?action=list&dir=".$gallery_Path."&srt=yes&lang=$Lang";
                $filename = "<a href='$linkname' target='_blank'>$filename1</a> ";
                //end
            }  
            else if($gallery_MediaType == "youtube")
            {
                $idy = explode(".",$filename1,-1);
                $idyoutube ="";
                foreach ($idy as $a)
                    $idyoutube .= $a;
                $linkname = 'https://www.youtube.com/watch?v='.$idyoutube;
                $filename = "<a href='$linkname' target='_blank'>$filename1</a> ";
                $linkY=AdminCreateLink("", array('yutube'), array($idyoutube));
                $videoyoutube='<iframe width="420" height="345"
                                src="http://www.youtube.com/embed/'.$idyoutube.'">
                                </iframe>';
                $icon = "<a style='display: none' class='fancybox-thumb' data-fancybox-type='iframe' title='$gallery_Caption' rel='fancybox-thumb' href='http://www.youtube.com/embed/".$idyoutube."' >$videoyoutube</a>";
                $icon .="<img class='allmedia_icon videoframe' src='$gallery_Path' class='allmedia_icon' value='$gallery_Path' alt='$gallery_Caption'>" ;
                
                
            }
            else if($this->IsVideos($gallery_MediaType))
            { 
                $newpath=$gallery_Path;
                $icon ="<a style='display: none' class='fancybox-thumb' title='' rel='fancybox-thumb' data-fancybox-type='iframe' href='$gallery_Path' >";
                $icon .= '<video  height="100%" width= "100%">
                        <source src="'.$newpath.'" type="video/'.$this->IsVideos($gallery_MediaType).'">
                            <img src="Programs/gallery/images/videos.png">
                        </video></a>';
                $icon .= '<video class="videoframe" id="video1" height="75px" width= "75px">
                        <source src="'.$newpath.'" type="video/'.$this->IsVideos($gallery_MediaType).'">
                            <img class="allmedia_icon" src="Programs/gallery/images/videos.png">
                        </video></a>';
                
                
            }
            else if($this->IsFile($gallery_MediaType))
            {
                $icon = "<img src='Programs/gallery/images/".$this->IsFile($gallery_MediaType)."' class='allmedia_icon'>";
            }
            else if($this->IsImage($gallery_MediaType))
            {
                $html='<div class="copyToClipboard simplebutton">'.copy_MapLocation.'</div> <div style="display: none;"><img class="images" alt="'.$gallery_Caption.'" title="'.$gallery_Caption.'" src="'.$WebsiteUrl . "" . $gallery_Path.'"  /></div>';
                
                $newpath=$gallery_Path;
                $name=basename($gallery_Path);
                $A=explode('/', $newpath, -1);
                $S=implode("/", $A);
                $newpath=$S."/thumbs/".$name;
                $e=file_exists($newpath);
                if($e)
                {
                    $icon = "<a class='fancybox-thumb' title='$gallery_Caption' rel='fancybox-thumb' href='$gallery_Path' ><img src='$newpath' class='allmedia_icon' value='$gallery_Path' alt='$name'></a>";
                }  
                else {
                    $icon = "<a class='fancybox-thumb' title='$gallery_Caption' rel='fancybox-thumb' href='$gallery_Path' ><img src='$gallery_Path' class='allmedia_icon' value='$gallery_Path' alt='$name'></a>";
                }
            }  
            else {
                $icon = "<img src='Programs/gallery/images/files.png' class='allmedia_icon'>";
            }
            // end
            
            // create table caption  
            if($gallery_Caption == "")
                $caption = "...";
            else
                $caption = $gallery_Caption;
            //end
            
           
            
            // create table file create date  
            if($gallery_AddDate == "")
            {
                $datecreate="...";
            }
            else
            {
                $datecreate=$gallery_AddDate;
            }
            //end
            
            
            
            // create table file media rank  
            if($gallery_MediaRank == "")
            {
                $mediarank="0";
            }
            else
            {
                $mediarank=$gallery_MediaRank;
            }
            //end
            // create table show hide
            if($gallery_visible == 1)
            {
                $visiblehiddenimg="<img src='Programs/gallery/admin/images/visible.png' alt='add' class='allmedia_icon_options'>";
            }
            else
            {
                $visiblehiddenimg="<img src='Programs/gallery/admin/images/hidden.png' alt='add' class='allmedia_icon_options'>";
            }
            $visiblehidden="<div galid='".$gallery_Path."' data-id='".$gallery_IdMedia."' class='showhide'>".$visiblehiddenimg."</div>";
            //end
            
            // create table comment
            $commentimg=' <img src="Programs/gallery/admin/images/talk.png" alt="comment"  class="allmedia_icon_options">';
            $link = AdminCreateLink("", array("prog", "subdo", "galid"), array("gallery", "cmntMedia", $gallery_IdMedia));
            $comment='<a href="'.$link.'" title="cmntMedia" >'.$commentimg.'</a>';
            //end
            
            // create table comment
            $editimg = '<img src="Programs/gallery/admin/images/edit.png" alt="edit" class="allmedia_icon_options"> ';
            $link =  AdminCreateLink("", array("prog", "subdo", "galid"), array("gallery", "editMedia", $gallery_IdMedia));
            $edit='<a href="'.$link.'" title="editMedia" >'.$editimg.'</a>';
            //end
            
            // create table comment
            $deleteimg = '<img src="Programs/gallery/admin/images/delete.png" alt="edit" value="'.$gallery_IdMedia.'" style="cursor:pointer" class="deletmedia allmedia_icon_options"> ';
            $link =  AdminCreateLink("", array("prog", "subdo", "galid"), array("gallery", "delMedia", $gallery_IdMedia));
            $delete=$deleteimg;
            //end
            $detailgallery = '<i class="fa fa-th  fa-2 detailth" value="'.$gallery_IdMedia.'"></i>';
            $values_to_put_arr = array($detailgallery,$gallery_Path,$icon,$filename,$caption,$datecreate,$html,$mediarank,$visiblehidden,$comment,$edit,$delete);
            return $values_to_put_arr;
        }    
        function count_file($query,$fields = "*",$tables=array("gallery"),$relation = "",$conditions = array(),$order = "desc",$groupby = "",$start = 0,$limit = 10)
            {
                $db = $this->get_db();
                $record_set = $db->get_results($query);
                if($record_set)
                {
                    $c=0;
                    foreach ($record_set as $row)
                    {
                        $c = $c + 1;
                    }
                    return $c;
                }
                else
                    return false;
            }
        function select_file_path($query){
            $db = $this->get_db();
            $record_set = $db->get_results($query);
            if($record_set)
            {
                foreach($record_set as $gallerys_record_row)
                {
                    return $gallerys_record_row->Path;
                }
            }
            return null;
            
        }
            
    }
?>