/*
 * jQuery File Upload Plugin JS Example 7.0
 * https://github.com/blueimp/jQuery-File-Upload
 *
 * Copyright 2010, Sebastian Tschan
 * https://blueimp.net
 *
 * Licensed under the MIT license:
 * http://www.opensource.org/licenses/MIT
 */

/*jslint nomen: true, unparam: true, regexp: true */
/*global $, window, document */

$(function () {
    "use strict";

    // Initialize the jQuery File Upload widget:
    $("#fileupload").fileupload({
        // Uncomment the following to send cross-domain cookies:
        //xhrFields: {withCredentials: true},
        url: "Programs/autobuy/jQueryFileUploadmaster/server/php/index.php?path="
    });

    // Enable iframe cross-domain access via redirect option:
    $("#fileupload").fileupload(
        "option",
        "redirect",
        window.location.href.replace(
            /\/[^\/]*$/,
            "Programs/autobuy/jQueryFileUploadmaster/cors/result.html?%s"
        )
    );

        // Load existing files:
        $.ajax({
            // Uncomment the following to send cross-domain cookies:
            //xhrFields: {withCredentials: true},
            url: $("#fileupload").fileupload("option", "url"),
            dataType: "json",
            context: $("#fileupload")[0]
        }).done(function (result) {
            $(this).fileupload("option", "done")
                .call(this, null, {result: result});
        });
    

});
