$(document).ready(initialize_admin_scripts);

function initialize_admin_scripts()
    {
        $('.news_pin_span').on('click',pin_or_unpin);
        $('#submit_fast_news').on('click',send_fast_news);
    }
    
function pin_or_unpin()
    {
        $(this).html($('#pin_loader_span').html());
        var news_id = $(this).attr('data-id');
        var ajax_data = {news_id : news_id};
        
        var pin_status = $(this).attr('data-pin');
        if(pin_status == 1)
            {
                ajax_data['status'] = 0;
            }
        else
            {
                ajax_data['status'] = 1;
            }
        var ajax_options = {url : 'Programs/news/admin/pin.php',context : this,data : ajax_data,type : 'POST',dataType : 'json'};
        
        var ajax_request = $.ajax(ajax_options);
        ajax_request.done(function(data){
           var new_status = data.new_status;
           $(this).attr('data-pin',new_status);
           //$('#pin_loader_img').appendTo($('#pin_loader_span'));
           //while($('#pin_loader_span').html() === '');
           if(data.status == 1)
                {
                    if(new_status == 1)
                         {
                             $(this).html('<img src="Programs/news/admin/images/unpin.png" />');
                         }
                     else
                         {
                             $(this).html('<img src="Programs/news/admin/images/pin.png" />');
                         }
                }
            else
                {
                    if(pin_status == 1)
                         {
                             $(this).html('<img src="Programs/news/admin/images/unpin.png" />');
                         }
                     else
                         {
                             $(this).html('<img src="Programs/news/admin/images/pin.png" />');
                         }
                }
        });
        
        ajax_request.fail(function(){
            console.log('fail');
            //$('#pin_loader_img').appendTo($('#pin_loader_span'));
            //while($('#pin_loader_span').html() === '');
            if($(this).attr('data-pin') == 1)
                {
                    $(this).html('<img src="Programs/news/admin/images/unpin.png" />');
                }
            else
                {
                    $(this).html('<img src="Programs/news/admin/images/pin.png" />');
                }
        });
    }
    
function send_fast_news()
    {
        if($('#fast_sender_loader').length > 0)
            return false;
        var infos = {};
        if($('#content').val().trim() == "")
            {
                $('#content').focus();
                return false;
            }
        infos['c'] = $('#content').val().trim();
        if($('#title').val().trim() != "")
            infos['ti'] = $('#title').val().trim();
        infos['u'] = 1;
        infos['d'] = 1;
        infos['a'] = $('#agency').val();
        infos['ca'] = $('#category').val();
        infos['u'] = $('#urgent').is(':checked')?1 : 0;
        infos['t'] = $('#token').val();
        infos['l'] = $('#language').val();
        infos['i'] = "uploads/news/pics/newspaper.png";
        var func1 = function()
            {
                $('#fast_sender_loader').find('i').removeClass('fa-spin fa-spinner').addClass('fa-check-circle');
                setTimeout(function()
                    {
                        $('#fast_sender_loader').remove();
                        $('#title,#content').val('');
                        $('#urgent').removeProp('checked');
                    },1000);
            };
        var func2 = function()
            {
                $('#fast_sender_loader').find('i').removeClass('fa-spin fa-spinner').addClass('fa-times-circle');
                setTimeout(function()
                    {
                        $('#fast_sender_loader').remove();
                    },3000);
            }
        infos = gather_fast_social_options(infos);
        infos = gather_fast_mobile_options(infos);
        var ajax_data = {op : 'f_n',i : infos,'internal_submit' : 1};
        var ajax_options = {data : ajax_data,dataType : 'json',type : 'POST',url : 'Programs/api/api_full.php'};
        ajax_options['success'] = function(data)
            {
                if(data.s === '1')
                    {
                        func1();
                    }
                else
                    {
                        func2();
                    }
            }
        ajax_options['error'] = function(error)
            {
                func1();
            }
        $(this).after('<span id="fast_sender_loader"> <i class="fa fa-spin fa-spinner"></i> </span>');
        $.ajax(ajax_options);
    }
    
function gather_fast_mobile_options(data)
    {
        var news_data = data;
        var mobile_options = {};
        if($('#mb_send_user_settings').is(':checked'))
            mobile_options['type'] = 0;//Just the title of the news will be sended
        else if($('#mb_send_specific').is(':checked'))
            {
                mobile_options['type'] = 1;//The news will be cutted on specific length
            }
        else if($('#mb_send_none').is(':checked'))
            {
                mobile_options['type'] = 2;//The news will be cutted on specific length
            }
        else
            {
                mobile_options['type'] = 3;//All the news will be sended
            }
        news_data['mobile'] = mobile_options;
        return news_data;
    }
    
function gather_fast_social_options(data)
    {
        var news_data = data;
        if(show_facebook_options == 1 && $('#news_admin_add_facebook_fieldset').is(':visible'))
            {
                var facebook_options = {};
                if($('#fb_send_title_part').is(':checked'))
                    facebook_options['type'] = 0;//Just the title of the news will be sended
                else if($('#fb_send_specific_part').is(':checked'))
                    {
                        facebook_options['type'] = 1;//The news will be cutted on specific length
                        facebook_options['length'] = parseInt($('#fb_send_message_length').val());
                    }
                else
                    {
                        facebook_options['type'] = 2;//All the news will be sended
                    }
                if($('#fb_send_picture').is(':checked'))
                    facebook_options['pic'] = 1;
                else
                    facebook_options['pic'] = 0;
                if($('#fb_send_link').is(':checked'))
                    facebook_options['link'] = 1;
                else
                    facebook_options['link'] = 0;
                facebook_options['fb'] = 1;
                news_data['fb'] = facebook_options;
            }
        if(show_whatsapp_options == 1 && $('#news_admin_add_whatsapp_fieldset').is(':visible'))
            {
                var whatsapp_options = {};
                if($('#wp_send_title_part').is(':checked'))
                    whatsapp_options['type'] = 0;//Just the title of the news will be sended
                else if($('#wp_send_specific_part').is(':checked'))
                    {
                        whatsapp_options['type'] = 1;//The news will be cutted on specific length
                        whatsapp_options['length'] = parseInt($('#wp_send_message_length').val());
                    }
                else
                    {
                        whatsapp_options['type'] = 2;//All the news will be sended
                    }
                if($('#wp_send_picture').is(':checked'))
                    whatsapp_options['pic'] = 1;
                else
                    whatsapp_options['pic'] = 0;
                if($('#wp_send_video').is(':checked'))
                    whatsapp_options['video'] = 1;
                else
                    whatsapp_options['video'] = 0;
                if($('#wp_send_location_checkbox').is(':checked'))
                    whatsapp_options['location'] = 1;
                else
                    whatsapp_options['location'] = 0;
                whatsapp_options['wa'] = 1;
                news_data['wa'] = whatsapp_options;
            }
        if(show_twitter_options == 1 && $('#news_admin_add_twitter_fieldset').is(':visible'))
            {
                var twitter_options = {};
                if($('#content').val().length > 0)
                    twitter_options['message']=$('#content').val();
                else
                    {
                        if($('#title').val().length > 0)
                            twitter_options['message'] = $('#title').val();
                    }
                if($('#tw_send_picture').is(':checked'))
                    twitter_options['pic'] = 1;
                else
                    twitter_options['pic'] = 0;
                if($('#tw_send_link').is(':checked'))
                    twitter_options['link'] = 1;
                else
                    twitter_options['link'] = 0;
                twitter_options['tw'] = 1;
                news_data['tw'] = twitter_options;
            }
        if(show_telegram_options == 1 && $('#news_admin_add_telegram_fieldset').is(':visible'))
            {
                var telegram_options = {};
                if($('#tg_send_title_part').is(':checked'))
                    telegram_options['type'] = 0;//Just the title of the news will be sended
                else if($('#tg_send_specific_part').is(':checked'))
                    {
                        telegram_options['type'] = 1;//The news will be cutted on specific length
                        telegram_options['length'] = parseInt($('#tg_send_message_length').val());
                    }
                else
                    {
                        telegram_options['type'] = 2;//All the news will be sended
                    }
                if($('#tg_send_picture').is(':checked'))
                    telegram_options['pic'] = 1;
                else
                    telegram_options['pic'] = 0;
                if($('#tg_send_video').is(':checked'))
                    telegram_options['video'] = 1;
                else
                    telegram_options['video'] = 0;
                if($('#tg_send_location_checkbox').is(':checked'))
                    telegram_options['location'] = 1;
                else
                    telegram_options['location'] = 0;
                telegram_options['tl'] = 1;
                news_data['tl'] = telegram_options;
            }
        return news_data;
    }