<?php
class news_selector
    {
        private $db;
        private $news;
        
        public function __construct($db)
            {
                $this->set_db($db);
            }
        function set_db($_db)
            {
                $this->db = $_db;
            }
            
        function get_db()
            {
                return $this->db;
            }
            
        function select_news($query,$fields = "*",$tables=array("news"),$relation = "",$conditions = array(),$order = "desc",$groupby = "",$start = 0,$limit = 10)
            {
                $db = $this->get_db();
                $news_record_set = $db->get_results($query);
                if($news_record_set)
                    return $news_record_set;
                else
                    return false;
            }
            
        function get_news($news_record_set,$_template,$call_back = NULL)
            {
                global $WebsiteUrl;
                $final_result = "";
                if(file_exists($_template))
                    $template = get_include_contents ($_template);
                else
                    $template = $_template;
                $template_tags_arr = template_parser::get_template_tags($template);
                $i = 0;
                foreach($news_record_set as $news_record_row)
                    {
                        if(is_array($news_record_set) && isset($news_record_set[$i]->NewsPic) && function_exists('get_news_picture'))
                            {
                                $news_record_set[$i]->NewsPic = get_news_picture($news_record_set[$i]->NewsPic);
                            }
                        $current_news_template = $template;
                        $news_id = isset($news_record_row->IdNews)?$news_record_row->IdNews : '';
                        $social_link = rtrim($WebsiteUrl,"/") . "/l.php?".$news_id;
                        $news_title = isset($news_record_row->Tilte)?strip_tags($news_record_row->Tilte): '';
                        $full_news = isset($news_record_row->FullMessage)?strip_tags($news_record_row->FullMessage): '';
                        $news_link = isset($news_record_row->Tilte) && isset($news_record_row->IdNews)?news_selector::generate_news_title_link($news_title, $news_id) : '';
                        $social_date = isset($news_record_row->Date)?socialDateDif(strtotime(date("Y-m-d H:i:s")), strtotime($news_record_row->Date), true) : '';
                        $urgent_class = isset($news_record_row->urgent) && $news_record_row->urgent == 1? ' urgent' : '';
                        $pinned_class = isset($news_record_row->pinned) && $news_record_row->pinned == 1? ' pinned' : '';
                        
                        $news_picture = isset($news_record_row->NewsPic) && function_exists("get_news_picture")?get_news_picture($news_record_row->NewsPic) : "uploads/news/pics/newspaper.png";
                        $gallery_picture = (strpos($news_picture,"newspaper.png")===false)?str_replace(array('uploads/news/pics/'),array('uploads/gallery/Albums/'),$news_picture) : "uploads/news/pics/newspaper.png";
                        if(!file_exists($gallery_picture))
                            $gallery_picture = $news_picture;
                        if(isset($news_record_row->news_pictures) && !empty($news_record_row->news_pictures))
                            {
                                if(strpos($full_news,$news_picture) !== false)
                                    $gallery_picture = "found";
                            }
                        if($call_back !== NULL)
                            {
                                $callback_result = call_user_func($call_back,$news_record_row,$current_news_template);
                                if(!is_array($callback_result))
                                    $current_news_template = $callback_result;
                                else
                                    {
                                        $current_news_template = $callback_result[0];
                                        $news_record_row = $callback_result[1];
                                    }
                            }
                        $tags_to_replace_arr = array('{$news_id}','{$news_link}','{$social_date}','{$urgent_class}','{$pinned_class}','{$social_link}','{$GalleryPic}');
                        $values_to_put_arr = array($news_id,$news_link,$social_date,$urgent_class,$pinned_class,$social_link,$gallery_picture);
                        foreach($template_tags_arr as $tag)
                            {
                                $tags_to_replace_arr[] = $tag;
                                $values_to_put_arr[] = template_parser::get_tag_value($news_record_row, $tag);
                            }
                        $current_news = str_replace($tags_to_replace_arr,$values_to_put_arr,$current_news_template);
                        $final_result .= $current_news;
                        $i++;
                    }
                return $final_result;
            }
        
        function parse_relation()
            {
                
            }
            
        function parse_conditions($conditions)
            {
                
            }
        static function generate_news_title_link($title,$news_id)
            {
                $title_link = str_replace(array('"', "'", "\\", "/", ":", "@"), array('', '', '', '', '', ''), $title);
                return CreateLink('',array('Prog','ns','idnews','title'),array('news','details',$news_id,mb_substr($title_link,0,35,"utf8")));
            }
    }
    
class template_parser
    {
        static function get_template_tags($template)
            {
                $template_tags = "";
                $preg_result = preg_match_all("/{(.*?)}/s", $template,$template_tags);
                return array_unique($template_tags[0]);
            }
            
        static function get_tag_value($object,$tag)
            {
                if(strpos($tag, '{$') === false)
                    {
                        $tag = str_replace(array('{','}'),array(''),$tag);
                        $value = defined($tag)?constant($tag) : $tag;
                    }
                else
                    {
                        $value = "";
                        $tag = str_replace(array('{$','}'),array(''),$tag);
                        if(strpos($tag,'|') !== false)
                            {
                                $tag_parameters = explode('|',$tag);
                                $tag_name = $tag_parameters[0];
                                $tag_length = isset($tag_parameters[1])?$tag_parameters[1] : false;
                                $strip_tags = isset($tag_parameters[2]) && $tag_parameters[2] == 0?false : true;
                                if(isset($object->$tag_name))
                                    {
                                        if($tag_length)
                                            {
                                                if($strip_tags)
                                                    $value = mb_substr(strip_tags ($object->$tag_name), 0,$tag_length,"utf8");
                                                else
                                                    $value = mb_substr($object->$tag_name, 0,$tag_length,"utf8");
                                            }
                                        else
                                            {
                                                if($strip_tags)
                                                    $value = strip_tags($object->$tag_name);
                                                else
                                                    $value = $object->$tag_name;
                                            }
                                    }
                                else
                                    {
                                        global $$tag_name;
                                        if(!empty($$tag_name))
                                            $value = mb_substr($$tag_name, 0,$tag_length,"utf8");
                                    }
                            }
                        else if(isset($object->$tag))
                            {
                                $value = $object->$tag;
                            }
                        else
                            {
                                global $$tag;
                                if(!empty($$tag))
                                    $value = $$tag;
                            }
                    }
                return $value;
            }
    }
?>