CREATE TABLE IF NOT EXISTS `app_visitors` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `android_id` text,
  `apple_id` text,
  `uuid` text NOT NULL,
  `PrefLang` varchar(1000) DEFAULT 'Arabic',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `facebook_category_objects` (
  `category_id` varchar(50) NOT NULL,
  `object_id` bigint(20) unsigned NOT NULL,
  `object_name` text
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `join_requests` (
  `phone` varchar(50) NOT NULL,
  `name` varchar(255) NOT NULL,
  `inserted` int(1) NOT NULL,
  `request_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `ip_address` varchar(20) DEFAULT NULL,
  UNIQUE KEY `phone` (`phone`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `news_rss_channels` (
  `channel_id` varchar(11) NOT NULL,
  `channel_name` text,
  `channel_link` text,
  `user_id` varchar(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `news_subscription` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `user_id` varchar(11) NOT NULL,
  `cat_id` varchar(11) NOT NULL COMMENT ' ',
  `only_urgent` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='      ' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `news_videos` (
  `id` int(11) NOT NULL,
  `news_id` varchar(11) NOT NULL,
  `videos_ids` text NOT NULL,
  `news_title` text
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `newsservice` (
  `IdNewsServ` varchar(11) NOT NULL COMMENT ' ',
  `WebName` varchar(1024) NOT NULL COMMENT ' ',
  `FeedName` varchar(35) NOT NULL COMMENT ' ',
  `FeedCode` varchar(10) NOT NULL COMMENT ' ',
  `FeedUrl` varchar(1024) NOT NULL COMMENT ' ',
  `FeedLang` varchar(15) NOT NULL COMMENT ' ',
  `Available` varchar(1) NOT NULL COMMENT '',
  PRIMARY KEY (`IdNewsServ`),
  UNIQUE KEY `FeedCode` (`FeedCode`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='   ';

CREATE TABLE IF NOT EXISTS `services` (
  `IdService` varchar(11) NOT NULL,
  `ServiceName` varchar(35) NOT NULL,
  `Available` varchar(1) NOT NULL,
  `AdminMustOk` varchar(1) NOT NULL,
  PRIMARY KEY (`IdService`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `whatsapp_channels` (
  `channel_id` int(11) NOT NULL COMMENT '  ',
  `number_id` int(11) NOT NULL COMMENT '  ',
  `channel_type` int(11) NOT NULL COMMENT '  |1-   2-  | 3  ',
  PRIMARY KEY (`channel_id`,`number_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `whatsapp_contacts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `contact_id` varchar(100) NOT NULL,
  `phone` varchar(100) NOT NULL,
  `picture` varchar(1000) NOT NULL,
  `name` varchar(1000) NOT NULL,
  `blocked` int(1) NOT NULL,
  `ignored` int(1) NOT NULL,
  `is_admin` int(1) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `contact_id` (`contact_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `whatsapp_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `group_id` varchar(100) NOT NULL,
  `name` varchar(1000) NOT NULL,
  `note` text NOT NULL,
  `owner` varchar(100) NOT NULL,
  `admin` varchar(100) NOT NULL,
  `creation_time` varchar(100) NOT NULL,
  `categories` varchar(5000) DEFAULT '',
  `members_count` int(11) NOT NULL,
  `sort` int(11) NOT NULL,
  `deleted` int(1) NOT NULL,
  `ignored` int(1) NOT NULL,
  `number` int(11) NOT NULL COMMENT '       ',
  `is_system` int(1) DEFAULT '0' COMMENT 'is a group cretaed by system',
  PRIMARY KEY (`id`),
  UNIQUE KEY `group_id` (`group_id`,`number`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `whatsapp_groups_subscription` (
  `group_id` int(11) NOT NULL,
  `cat_id` varchar(11) NOT NULL,
  PRIMARY KEY (`group_id`,`cat_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `whatsapp_group_members` (
  `group_id` varchar(100) NOT NULL,
  `contact_id` int(11) NOT NULL,
  `is_admin` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `whatsapp_lists` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(1000) NOT NULL,
  `note` varchar(1000) DEFAULT NULL,
  `creation_time` varchar(1000) DEFAULT NULL,
  `sort` int(11) DEFAULT '0',
  `deleted` int(1) NOT NULL,
  `ignored` int(1) DEFAULT '0',
  `members_count` int(11) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `whatsapp_lists_subscription` (
  `list_id` int(11) NOT NULL,
  `cat_id` varchar(11) NOT NULL,
  PRIMARY KEY (`list_id`,`cat_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `whatsapp_list_members` (
  `contact_id` int(11) NOT NULL,
  `list_id` int(11) NOT NULL,
  `categories` varchar(5000) DEFAULT '',
  PRIMARY KEY (`contact_id`,`list_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `whatsapp_numbers` (
  `id` int(11) NOT NULL,
  `phonenumber` varchar(100) NOT NULL,
  `password` varchar(100) NOT NULL,
  `code` varchar(50) NOT NULL,
  `is_bot` tinyint(1) NOT NULL,
  `active` tinyint(1) NOT NULL,
  `backup_for` int(11) DEFAULT '0' COMMENT '       ',
  `last_update_time` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `whatsapp_request_tries` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `day` int(2) NOT NULL,
  `month` int(2) NOT NULL,
  `year` int(4) NOT NULL,
  `phone` varchar(50) NOT NULL,
  `uuid` varchar(50) NOT NULL,
  `verified` int(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `whatsapp_settings` (
  `group_subscription` text CHARACTER SET utf8 NOT NULL,
  `user_group_subscription` text CHARACTER SET utf8,
  `list_subscription` text CHARACTER SET utf8 NOT NULL,
  `stop_service` text CHARACTER SET utf8 NOT NULL,
  `contactus` text CHARACTER SET utf8,
  `group_terms` text CHARACTER SET utf8,
  `broadcast_stopped` text CHARACTER SET utf8,
  `support_number` text CHARACTER SET utf8,
  `welcome_message` text CHARACTER SET utf8,
  `group_subscribed` text CHARACTER SET utf8,
  `list_subscribed` text CHARACTER SET utf8,
  `user_group_note` text CHARACTER SET utf8,
  `user_no_group_note` text CHARACTER SET utf8 NOT NULL,
  `talk_reaction` int(1) DEFAULT '0' COMMENT 'What to do when someone talk in a group of our groups . 0:ignore|1:email|2:leave group + terms(private message)|3:leave groups just if user send bad words',
  `website_name` text CHARACTER SET utf8,
  `logo_path` text CHARACTER SET utf8,
  `terms_prefix` text CHARACTER SET utf8 NOT NULL,
  `terms_suffix` text CHARACTER SET utf8 NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE IF NOT EXISTS `whatsapp_verified_mobile_numbers` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `phone` varchar(50) NOT NULL,
  `verified` int(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `telegram_contacts` (
  `chat_id` varchar(100) NOT NULL DEFAULT '',
  `first_name` text NOT NULL,
  `last_name` text NOT NULL,
  PRIMARY KEY (`chat_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `whatsapp_backup_numbers` (
  `id` int(11) NOT NULL,
  `phone` varchar(40) NOT NULL,
  `password` varchar(40) NOT NULL,
  `active` int(1) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `sms_messages` (
  `id` bigint(20) NOT NULL,
  `sender` int(11) NOT NULL,
  `message` varchar(10000) NOT NULL,
  `amount` decimal(10,0) NOT NULL,
  `balance_message` varchar(10000) NOT NULL,
  `balance` decimal(10,2) NOT NULL,
  `line_provider` smallint(1) NOT NULL COMMENT '1:Alfa,2:Mtc',
  `message_time` datetime DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `sms_subscriber` (
  `id` int(11) NOT NULL,
  `name` varchar(10000) DEFAULT NULL,
  `regdate` datetime DEFAULT NULL,
  `phone` varchar(20) NOT NULL,
  `expdate` datetime DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

alter table `params` add `max_channels` int(2) NOT NULL after `youtube_password`,add `bad_words` text after `max_channels`;
alter table params add column `application_token` varchar(1000) DEFAULT NULL;
ALTER TABLE `sms_messages` ADD PRIMARY KEY (`id`),ADD KEY `index_sender` (`sender`);
ALTER TABLE `sms_messages` MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;
ALTER TABLE `sms_messages` ADD CONSTRAINT `fk_sender_subscriber` FOREIGN KEY (`sender`) REFERENCES `sms_subscriber` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `sms_subscriber` ADD PRIMARY KEY (`id`),ADD UNIQUE KEY `unique_phone` (`phone`);
ALTER TABLE `sms_subscriber` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;
ALTER TABLE `whatsapp_backup_numbers` ADD PRIMARY KEY (`id`);
ALTER TABLE `whatsapp_backup_numbers` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;
ALTER TABLE `whatsapp_numbers` ADD `blocked` INT( 1 ) NOT NULL DEFAULT '0' COMMENT 'this number is blocked by whatsapp' AFTER `last_update_time` ;
ALTER TABLE `whatsapp_channels` ADD INDEX ( `channel_id` ) ;
ALTER TABLE `whatsapp_channels` ADD INDEX ( `number_id` ) ;
ALTER TABLE `whatsapp_contacts` ADD INDEX ( `id` ) ;
ALTER TABLE `whatsapp_contacts` ADD INDEX ( `contact_id` ) ;
ALTER TABLE `whatsapp_contacts` ADD INDEX ( `blocked` ) ;
ALTER TABLE `whatsapp_contacts` ADD INDEX ( `is_admin` ) ;
ALTER TABLE `whatsapp_contacts` ADD INDEX ( `ignored` ) ;
ALTER TABLE `whatsapp_group_members` ADD INDEX ( `group_id` ) ;
ALTER TABLE `whatsapp_group_members` ADD INDEX ( `contact_id` ) ;
ALTER TABLE `whatsapp_numbers` ADD INDEX ( `id` ) ;

alter table whatsapp_groups add column members text NULL;

INSERT INTO `whatsapp_settings` (`group_subscription`, `user_group_subscription`, `list_subscription`, `stop_service`, `contactus`, `group_terms`, `broadcast_stopped`, `support_number`, `welcome_message`, `group_subscribed`, `list_subscribed`, `user_group_note`, `user_no_group_note`, `talk_reaction`, `website_name`, `logo_path`, `terms_prefix`, `terms_suffix`) VALUES ('', NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '0', NULL, NULL, '', '');