CREATE TABLE IF NOT EXISTS `news_report` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_news` varchar(11) NOT NULL,
  `nickname` varchar(20) NOT NULL,
  `time_sent` datetime NOT NULL,
  `time_read` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `news_images` (
  `id` int(11) NOT NULL,
  `news_id` varchar(11) NOT NULL,
  `images_paths` text NOT NULL,
  `news_title` text
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ads_banner` (
  `id_ads_banner` int(11) NOT NULL AUTO_INCREMENT,
  `id_ads_position` int(11) NOT NULL,
  `id_price_type` int(11) NOT NULL,
  `id_campaing` int(11) NOT NULL,
  `name` text NOT NULL,
  `views` bigint(20) NOT NULL,
  `clicks` bigint(20) NOT NULL,
  `period` int(11) NOT NULL,
  `code` text NOT NULL,
  `url` text NOT NULL,
  `admin_ok` tinyint(4) NOT NULL DEFAULT '0',
  `paused` tinyint(4) NOT NULL DEFAULT '0',
  `deleted` int(1) NOT NULL DEFAULT '0',
  `title` text NOT NULL,
  `desc` text NOT NULL,
  `url_text` text NOT NULL,
  `image_src` text NOT NULL,
  `end_date` datetime NOT NULL DEFAULT '9999-12-31 00:00:00',
  PRIMARY KEY (`id_ads_banner`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `ads_campaign` (
  `id_campaing` int(11) NOT NULL AUTO_INCREMENT,
  `id_user` varchar(11) NOT NULL,
  `name` text NOT NULL,
  `start_date` datetime NOT NULL,
  `end_date` datetime NOT NULL,
  `budget` double NOT NULL,
  `spent` double NOT NULL,
  `admin_ok` tinyint(4) NOT NULL,
  `paused` tinyint(4) NOT NULL,
  `deleted` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_campaing`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `ads_cost` (
  `id_ads_price_list` int(11) NOT NULL,
  `id_ads_price_type` int(11) NOT NULL,
  `id_ads_position` int(11) NOT NULL,
  `price` double NOT NULL,
  `price_dealer` double NOT NULL,
  PRIMARY KEY (`id_ads_price_list`,`id_ads_price_type`,`id_ads_position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `ads_position` (
  `id_ads_position` int(11) NOT NULL AUTO_INCREMENT,
  `name` text NOT NULL,
  `type` tinyint(4) NOT NULL COMMENT '0: click, 1:view , 2:period',
  `google_slot` varchar(50) NOT NULL,
  `width` int(11) NOT NULL,
  `height` int(11) NOT NULL,
  PRIMARY KEY (`id_ads_position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `ads_price_list` (
  `id_ads_price_list` bigint(20) NOT NULL AUTO_INCREMENT,
  `from_date` datetime NOT NULL,
  `to_date` datetime NOT NULL,
  `name` text NOT NULL,
  PRIMARY KEY (`id_ads_price_list`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `ads_price_type` (
  `id_ads_price_type` int(11) NOT NULL AUTO_INCREMENT,
  `type` tinyint(4) NOT NULL COMMENT '0: click , 1: view , 2: period',
  `name` varchar(100) NOT NULL,
  PRIMARY KEY (`id_ads_price_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `ads_settings` (
  `id` int(11) NOT NULL,
  `google_pub` text NOT NULL,
  `background` text NOT NULL,
  `welcomepage` text NOT NULL,
  `group_dealer` varchar(11) NOT NULL,
  `currency` varchar(3) NOT NULL,
  `payments_way` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `ads_transactions` (
  `id_ads_transactions` int(11) NOT NULL AUTO_INCREMENT,
  `id_user` varchar(11) NOT NULL,
  `debit` double NOT NULL,
  `credit` double NOT NULL,
  `note` text NOT NULL,
  `type` text NOT NULL COMMENT 'cash , wu, cc',
  `date` datetime NOT NULL,
  PRIMARY KEY (`id_ads_transactions`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

INSERT INTO `ads_price_type` (`id_ads_price_type`, `type`, `name`) VALUES
(1, 0, 'زيارة'),
(2, 1, 'ألف مشاهدة'),
(3, 2, 'يوم كامل');

INSERT INTO `ads_settings` (`id` ,`google_pub` ,`background` ,`welcomepage` ,`group_dealer` ,`currency` ,`payments_way`)VALUES ('', '', '', '', '', '', '');

alter table marques add `IdNews` varchar(11) NOT NULL after `Deleted`;
alter table cclang add `ccode` int(5) NOT NULL after `rank`;

alter table `params` add `android_key` text NOT NULL after `UpdateName`,
add `apple_key` text NOT NULL after `android_key`,
add `awsAccessKey` varchar(50) NOT NULL COMMENT 'Amazon cloud access key' after `apple_key`,
add `awsSecretKey` varchar(100) NOT NULL COMMENT 'amazon cloud secret key' after `awsAccessKey`,
add `youtube_api_key` varchar(100) NOT NULL after `awsSecretKey`,
add `youtube_username` varchar(100) NOT NULL after `youtube_api_key`,
add `youtube_password` varchar(100) NOT NULL;

alter table users 
add `verification_code` varchar(50) NOT NULL DEFAULT '' after `CellNbr`,
add `code_sent` int(1) NOT NULL DEFAULT '0' after `verification_code`,
add `last_code_sent` varchar(50) DEFAULT NULL after `code_sent`,
add `phone_verified` varchar(50) NOT NULL DEFAULT ' ' after `last_code_sent`,
add `user_video` text NOT NULL COMMENT '����� ������ �� ��������' after `UserPic`,
add `android_id` text NOT NULL after `LastSession`,
add `apple_id` text NOT NULL after `android_id`,
add `uuid` text COMMENT 'device unique id' after `apple_id`,
add `app_token` text NOT NULL COMMENT 'session number for mobile app' after `uuid`;

alter table catlang 
add `sort` tinyint(1) NOT NULL DEFAULT '0' COMMENT '����� �������� �� ��� ����' after `Deleted`,
add `prefix` varchar(35) NOT NULL COMMENT ' ��� ����� ��� ��������' after `sort`;

ALTER TABLE `newslang` ADD `tags` VARCHAR( 1000 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL AFTER `Note`;


ALTER TABLE `news` 
ADD column `active_by` varchar(11) NOT NULL,
ADD column `del_by` varchar(11) NOT NULL,
ADD column `uuid` text,
ADD column `location` text NOT NULL COMMENT 'geo location x,y',
ADD column `pinned` int(11) NOT NULL DEFAULT '0',
ADD column `urgent` int(1) NOT NULL DEFAULT '0' COMMENT '��� ����',
ADD column `agency` varchar(20) NOT NULL COMMENT '��� �������� ����� ',
ADD column `tags` text,
ADD column `news_pictures` varchar(1000) DEFAULT NULL,
ADD column `news_videos` varchar(1000) DEFAULT NULL,
ADD column `news_audios` VARCHAR( 1000 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
ADD column `youtube_videos` varchar(5000) DEFAULT NULL,
ADD column `news_link` varchar(1000) DEFAULT NULL,
ADD column `creation_date` DATETIME NULL AFTER `IdUserName`;

alter table blocks add `admin_last_visit` datetime NOT NULL after `UpdateDesc`;

alter table `programs` add `admin_last_visit` datetime NOT NULL after `UpdateDesc`;

ALTER TABLE `poolusers` ADD PRIMARY KEY ( `UserId` , `Idpt` , `idpc` ) ;
ALTER TABLE `gallery` CHANGE `Path` `Path` VARCHAR( 1000 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ;
ALTER TABLE `params` CHANGE `DateGmt` `DateGmt` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '��� ������ ������� �������';

ALTER TABLE `catlang` ADD INDEX ( `sort` ) ;
ALTER TABLE `news` ADD INDEX ( `urgent` ) ;
ALTER TABLE `newscategoies` ADD INDEX ( `IdNews` ) ;
ALTER TABLE `newscategoies` ADD INDEX ( `IdCat` ) ;
ALTER TABLE `newslang` ADD INDEX ( `IdLang` ) ;
ALTER TABLE `newslang` ADD INDEX ( `IdNews` ) ;
ALTER TABLE `news_images` ADD INDEX ( `id` ) ;
ALTER TABLE `news_images` ADD INDEX ( `news_id` ) ;

ALTER TABLE `gallery` CHANGE `Path` `Path` VARCHAR( 1000 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ;
ALTER TABLE `gallery` ADD INDEX ( `Path` ) ;
ALTER TABLE `users` CHANGE `Gmt` `Gmt` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '���� ������� �������';
ALTER TABLE `gallery` ADD `visible` int(1) NULL DEFAULT '0' AFTER `visible`;
ALTER TABLE `gallery` ADD `ParentId` VARCHAR( 11 ) NULL DEFAULT '0' AFTER `visible`;
ALTER TABLE `news` CHANGE `news_pictures` `news_pictures` VARCHAR( 10000 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ;
ALTER TABLE `news` CHANGE `NewsPic` `NewsPic` VARCHAR( 1000 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'صورة للخبر';


UPDATE `thm_default_slider` SET `id`='20160000001' WHERE `id` = '1';
UPDATE `thm_default_slider` SET `id`='20160000002' WHERE `id` = '2';
UPDATE `thm_default_slider` SET `id`='20160000003' WHERE `id` = '3';
UPDATE `thm_default_slider` SET `id`='20160000004' WHERE `id` = '4';
UPDATE `thm_default_slider` SET `id`='20160000000' WHERE `id` = '0';
UPDATE `thm_default_caption` SET `id`='20160000001' WHERE `id` = '1';
UPDATE `thm_default_caption` SET `id`='20160000002' WHERE `id` = '2';
UPDATE `thm_default_caption` SET `id`='20160000003' WHERE `id` = '3';
UPDATE `thm_default_caption` SET `id`='20160000004' WHERE `id` = '4';
UPDATE `thm_default_caption` SET `id`='20160000000' WHERE `id` = '0';
ALTER TABLE `thm_default_caption` ADD PRIMARY KEY(`id`,`id_lang`);

ALTER TABLE `newslang` CHANGE `Tilte` `Tilte` VARCHAR( 256 ) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL ,
CHANGE `SubTitle` `SubTitle` VARCHAR( 35 ) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT 'العنوان الفرعي للخبر',
CHANGE `Breif` `Breif` TEXT CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT 'مختصر الخبر',
CHANGE `FullMessage` `FullMessage` LONGTEXT CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT 'الخبر كاملا'
